# -*- mode: python; indent-tabs-mode: nil; py-indent-offset: 4; coding: utf-8 -*-
# http://vt5hknv6sblkgf22.onion/tutorials/over_the_river.html

import sys
import os
import getpass
from stem.control import Controller

from tor_controller import get_controller

def iMain(lArgs=None):
    if lArgs is None:
        lArgs = sys.argv[1:]
    try:
        if os.path.exists('/run/tor/control'):
            controller = get_controller(unix='/run/tor/control')
        else:
            controller = get_controller(port=9051)
    
        password = os.environ.get('TOR_CONTROLLER_PASSWORD')
        controller.authenticate(password)
    
        for elt in lArgs:
            desc = controller.get_hidden_service_descriptor(elt, await_result=True, timeout=None)
            print(f"{desc} get_hidden_service_descriptor\n")
            l = desc.introduction_points()
            if l:
                print(f"{elt} NO introduction points\n")
                continue
            print(f"{elt} introduction points are...\n")
    
            for introduction_point in l:
                print('  %s:%s => %s' % (introduction_point.address,
                                        introduction_point.port,
                                        introduction_point.identifier))
    
    except Exception as e:
        print(e)
    finally:
        del controller
    return 0

lKNOWN_ONIONS = [
  'facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd', # facebook
  'duckduckgogg42xjoc72x3sjasowoarfbgcmvfimaftt6twagswzczad', # ddg
  'zkaan2xfbuxia2wpf7ofnkbz6r5zdbbvxbunvp5g2iebopbfc4iqmbad', # hks
]

if __name__ == '__main__':
    if len(sys.argv) <= 1:
        lArgs = lKNOWN_ONIONS
    else:
        lArgs = sys.argv[1:] 
    sys.exit(iMain())

