# -*-mode: python; py-indent-offset: 2; indent-tabs-mode: nil; coding: utf-8-unix -*-
# https://stem.torproject.org/tutorials/examples/exit_used.html

import functools
import sys
import getpass
import os

from stem import StreamStatus
from stem.control import EventType, Controller
from tor_controller import set_socks_proxy
from tor_controller import get_controller

global LOG
import logging
LOG = logging.getLogger('map_address')

def sMapaddressResolv(target, iPort=9051):
    try:
        if os.path.exists('/run/tor/control'):
            controller = get_controller(unix='/run/tor/control')
        else:
            controller = get_controller(port=9051)
    
        password = os.environ.get('TOR_CONTROLLER_PASSWORD')
        controller.authenticate(password)

        map_dict = {"0.0.0.0": target}
        map_ret = controller.map_address(map_dict)

        return map_ret
    except Exception as e:
        LOG.exception(e)

if __name__ == '__main__':
    if len(sys.argv) < 2:
        target = "l2ct3xnuaiwwtoybtn46qp2av4ndxcguwupzyv6xrsmnwi647vvmwtqd"
    else:
        target = sys.argv[1]
    print(sMapaddressResolv(target))

